package com.izouma.awesomeadmin.web;

import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.SysMenu;
import com.izouma.awesomeadmin.service.SysMenuService;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * sys_menu controller类
 * Tue Apr 10 18:09:44 CST 2018  Suo Chen Cheng
 */
@Controller
@RequestMapping("/sysMenu")
@RequiresAuthentication
public class SysMenuController {

    @Autowired
    private SysMenuService sysMenuService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(SysMenu record) {

        List<SysMenu> pp = sysMenuService.getSysMenuList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getSysMenu", method = RequestMethod.GET)
    @ResponseBody
    public Result getSysMenu(@RequestParam(required = false, value = "id") String id) {

        SysMenu data = sysMenuService.getSysMenuById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(SysMenu record) {

        SysMenu data = sysMenuService.getSysMenu(record);
        return new Result(true, data);
    }

    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, SysMenu record) {

        Map<String, Object> result = new HashMap<>();

        List<SysMenu> pp = sysMenuService.getSysMenuByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }

    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(SysMenu record) {

        boolean num = sysMenuService.createSysMenu(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateSysMenu(SysMenu record) {

        boolean num = sysMenuService.updateSysMenu(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteSysMenu(@RequestParam(required = true, value = "id") String id) {

        boolean num = sysMenuService.deleteSysMenu(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    @RequestMapping(value = "/menuTree", method = RequestMethod.GET)
    @ResponseBody
    public Result menuTree() {
        List<SysMenu> trees = sysMenuService.getMenuTree();
        if (trees != null) {
            return new Result(true, trees);
        }
        return new Result(false, "获取失败");
    }

    @RequestMapping(value = "/userMenuTree", method = RequestMethod.GET)
    @ResponseBody
    public Result userMenuTree(@RequestParam("userId") Integer userId) {
        List<SysMenu> trees = sysMenuService.getMenuTree(userId);
        if (trees != null) {
            return new Result(true, trees);
        }
        return new Result(false, "获取失败");
    }

}

